/* Own configuration library to assume compatibility
   with OE5BPA's TTGO T-Beam APRS Tracker. */

#include <Arduino.h>
#include "M5ModemConfig.h"


Modem::Modem() :
  _spiSettings(8E6, MSBFIRST, SPI_MODE0),
  _ss(LORA_DEFAULT_SS_PIN), _reset(LORA_DEFAULT_RESET_PIN), _dio0(LORA_DEFAULT_DIO0_PIN)
  //_frequency(0),
  //_packetIndex(0),
  //_implicitHeaderMode(0),
  //_onReceive(NULL)
{
  // overide Stream timeout value
  //setTimeout(0);
}

uint8_t Modem::readRegister(uint8_t address) {
  return singleTransfer(address & 0x7f, 0x00);
}

void Modem::writeRegister(uint8_t address, uint8_t value) {
  singleTransfer(address | 0x80, value);
}

uint8_t Modem::singleTransfer(uint8_t address, uint8_t value) {
  uint8_t response;

  digitalWrite(_ss, LOW);

  SPI.beginTransaction(_spiSettings);
  SPI.transfer(address);
  response = SPI.transfer(value);
  SPI.endTransaction();

  digitalWrite(_ss, HIGH);

  return response;
}
